<template>
    <header
      class="z-[60] sticky top-0 overflow-x-hidden"
      ref="headEl"
      :style="`--header-height: ${headElHeight}px`"
    >
      <div class="top-part z-[60]">
        <div class="info flex-wrap">
          <div class="left">
            <nuxt-link
              v-if="logo && !logo.IsHidden"
              :to="logo.HyperLink ? `/${logo.HyperLink}` : '/'"
            >
              <img :src="logo.ImagePath" class="logo" />
            </nuxt-link>
            <theme-desktop-playful-components-header-nav />
          </div>
          <div class="right">
            <template v-if="isAuth">
              <div v-if="isAuth" class="flex gap-4" style="color: var(--text5)">
                <lazy-wallet-info-global v-if="isAuth" />
              </div>
              <div v-if="!isHiddenDepostWithdrawal" class="divider max-[585px]:hidden"></div>
              <nuxt-link v-if="!isHiddenDepostWithdrawal" to="?uc=/deposit" class="header-btn bg-secondary max-[585px]:hidden uppercase" :id="ID.DEPOSIT_HEADER_DESKTOP">
                {{ $t(`deposit${isBhinbhin}`) }}
              </nuxt-link>
              <div class="divider max-[585px]:hidden"></div>
            </template>
            <template v-else>
              <div class="flex gap-2">
                <nuxt-link
                  v-if="isDesktop"
                  to="/login"
                  class="header-btn bg-secondary max-[585px]:hidden"
                >
                  {{ $t("capital_login") }}
                </nuxt-link>
                <nuxt-link
                  v-if="!register.IsHidden && isDesktop"
                  to="/register"
                  class="header-btn bg-primary max-[585px]:hidden"
                  :id="ID.SIGNUP"
                >
                  {{ $t("joinnow") }}
                </nuxt-link>
                <nuxt-link
                  v-if="!agentCooperation.IsHidden"
                  to="/agent-cooperation"
                  class="header-btn bg-primary max-[585px]:hidden"
                >
                  {{ $t("agent_cooperation") }}
                </nuxt-link>
              </div>
              <div class="divider max-[585px]:hidden"></div>
            </template>
            <language-global v-if="isDesktop" class="max-[585px]:hidden"/>
            <!-- <div v-if="isDesktop" class="divider"></div> -->
            <!-- <div v-if="isDesktop" class="time-block">
              <span>{{ datetimeDisplay }}</span>
            </div> -->
            <div class="divider max-[585px]:hidden"></div>
            <theme-desktop-global-components-menu-drawer />
          </div>
        </div>
      </div>
    </header>
  </template>

  <script setup lang="ts">
  import {
    IThemePropertiesFromApi,
    ThemePropertiesFromApiDto,
  } from "~~/models/companyThemePropertiesRespone";
  import { useDisplayLocalTime } from "@/composables/useTheme";
  import commonHelper from '../../utils/commonHelper';
  import { store } from "~~/store";
  const isAuth = computed(() => store.state.auth);
  const isDesktop = useIsDesktop();
  const headEl = ref();
  const headElHeight = ref<number>(106);
  const logo = computed(() => {
    const found = store.state.companyThemePropertiesFromApi.ThemeProperties.find(
      (property) => property.HtmlId === "logo"
    );
    if (!found) return undefined;
    return new ThemePropertiesFromApiDto(found);
  });
  const register = computed(
    (): IThemePropertiesFromApi =>
      themePropertyHelper.getSingleThemeProperty(
        store.state.companyThemePropertiesFromApi.ThemeProperties,
        "register"
      )
  );
  const dimension = useResponsiveDimensions();
  watch(
    () => dimension.sizes.width,
    () => {
      nextTick(() => {
        setTimeout(() => {
          if (headEl.value && headEl.value.clientHeight) {
            headElHeight.value = headEl.value.clientHeight;
          } else {
            headElHeight.value = 106;
          }
        }, 1000);
      });
    },
    { deep: true, immediate: true }
  );
  const agentCooperation = computed(
    (): IThemePropertiesFromApi =>
      themePropertyHelper.getSingleThemeProperty(
        store.state.companyThemePropertiesFromApi.ThemeProperties,
        "agent_cooperation"
      )
  );
  const { datetimeDisplay } = useDisplayLocalTime();
  const { isBhinbhin } = commonHelper;
  const isHiddenDepostWithdrawal = computed(
  (): IThemePropertiesFromApi =>
    themePropertyHelper.getSingleThemeProperty(
      store.state.companyThemePropertiesFromApi.ThemeProperties,
      "deposit_withdraw"
    ).IsHidden
);
  </script>

  <style scoped>
  header {
    display: flex;
    flex-direction: column;
    align-items: center;
  }
  .top-part {
    display: flex;
    padding: 16px 24px;
    flex-direction: column;
    align-items: center;
    gap: 12px;
    align-self: stretch;
    background: var(--background5);
  }

  header .info {
    display: flex;
    justify-content: space-between;
    align-items: center;
    align-self: stretch;
  }

  header .logo {
    width: 96px;
    height: 32px;
    max-width: 96px;
    object-fit: contain;
  }

  header .left,
  header .right {
    display: flex;
    align-items: center;
    gap: 16px;
  }

  .divider {
    width: 1px;
    height: 32px;
    background: var(--border, #4d5080);
  }

  header .header-btn {
    padding: 8px 16px;
    border-radius: 4px;
    color: var(--text5);
    text-align: center;
    font-size: 14px;
    font-style: normal;
    font-weight: 500;
    line-height: normal;
  }

  header .header-btn .bg-secondary {
    background-color: var(--secondary);
  }

  header .header-btn .bg-primary {
    background-color: var(--primary);
  }

  header .time-block {
    display: flex;
    height: 32px;
    padding: 8px 12px;
    align-items: center;
    gap: 8px;
    border-radius: 8px;
    background: linear-gradient(0deg, rgba(0, 0, 0, 0) 0%, rgba(0, 0, 0, 0) 100%),
      var(--background5, #1d2052);
    color: var(--text5, #fff);
    text-align: center;
    font-size: 12px;
    font-style: normal;
    font-weight: 500;
    line-height: normal;
    text-transform: uppercase;
  }
  .top-part::after {
    position: absolute;
    content: "";
    height: 2px;
    background: var(--border);
    right: 0;
    left: 0;
    bottom: 0;
  }
  </style>
  <style lang="scss">
  [layout="playful"] {
    .top-part {
      .content {
        padding: 8px 12px;
        .label {
          font-size: 12px;
        }
      }
    }
    .el-carousel {
      .el-carousel__container {
        height: 287px !important;
      }
    }
  }
  .playful-nav-link.header-nav-link.active {
    border-radius: 4px;
    opacity: 0.8;
    background: linear-gradient(0deg, rgba(255, 255, 255, 0.15) 0%, rgba(255, 255, 255, 0.15) 100%), var(--Background5, #1D2052);
  }
  </style>
